#include <limits.h>
#include <errno.h>


#define ERRSTRING strerror (errno)
#define COMMAND_SIZE  PIPE_BUF


#define COMMAND_TEST       0  /*  No wait, signal                            */
#define COMMAND_NEED       1  /*  Wait, signal                               */
#define COMMAND_ROLLBACK   2  /*  Wait, signal                               */
#define COMMAND_DUMP_LIST  3  /*  No wait, no signal                         */
#define COMMAND_PROVIDE    4  /*  Wait, signal                               */
#define COMMAND_CLEAR	   5  /*  No wait, signal			     */

#define CLEAR_FLAGS  (~0xC0000000)  /* and-mask for clearing flags 	     */
#define FLAG_FORCE	0x80000000  /* flag for COMMAND_ROLLBACK 	     */

#define SIG_PRESENT        SIGUSR1  /*  Service is available                 */
#define SIG_STOPPED        SIGUSR1  /*  Service was stopped OK               */
#define SIG_NOT_PRESENT    SIGUSR2  /*  Not present, but that's OK           */
#define SIG_FAILED         SIGPOLL  /*  Startup failed                       */
#define SIG_NOT_STOPPED    SIGPOLL  /*  Failed to stop                       */
#define SIG_NOT_CHILD      SIGPOLL  /*  Not a child of init                  */
#define SIG_ROLLBACK	   SIGURG   /*  Rollback in progress		     */
#define SIG_NO_INFO	   SIGURG   /*  No info about service available	     */

struct command_struct  /*  Must always be COMMAND_SIZE  */
{
    unsigned int command;
    pid_t pid;
    pid_t ppid;
    char name[1];
};
